/*
 * digitalWatch.js
 * By Denis Dube, 2006
 * Demonstration of AJAX principles and statechart controlled behaviour
 */

//==============================================================================
//Global variables
//==============================================================================


var insertButton; var insertButtonActive = true;
var moveButton; var moveButtonActive = false;
var deleteButton; var deleteButtonActive = false;
var id_line = 1;
var num = 0;



//==============================================================================
//Update with the server
//==============================================================================



function queryServerNow(req){
  // Query the server and update the SVG with any changes using setAttribute
	req.onreadystatechange = function(){
    if (req.readyState == 4 && req.responseText) {
		eval(req.responseText);
    }
  }
  req.send(null);
}

//==============================================================================
//Handle User Input
//==============================================================================

function move_delete(id,evt)
{
	var req = AJAX("/mouse1press_select?"+evt.clientX+"?"+evt.clientY+"?"+id);
  	queryServerNow(req);
	req.send(evt);
}

function insert_selected (evt)
{
	insertButtonActive = true;
	var insert_button = svgdoc.getElementById("select_insert");
	var move_button = svgdoc.getElementById("select_move");
	var delete_button = svgdoc.getElementById("select_delete");
	insert_button.setAttributeNS(null,"style","fill:red; stroke:black");
	move_button.setAttributeNS(null,"style","fill:black; stroke:black");
	delete_button.setAttributeNS(null,"style","fill:black; stroke:black");
	var insert_text = svgdoc.getElementById("texte_inser");
	var move_text = svgdoc.getElementById("texte_move");
	var delete_text = svgdoc.getElementById("texte_delete");
	insert_text.setAttributeNS(null,"fill","red");
	move_text.setAttributeNS(null,"fill","black");
	delete_text.setAttributeNS(null,"fill","black");
	var req = AJAX("insertButtonpressed");
  	queryServerNow(req);
	req.send(evt);
}

function move_selected (evt)
{
	moveButtonActive = true;
	var insert_button = svgdoc.getElementById("select_insert");
	var move_button = svgdoc.getElementById("select_move");
	var delete_button = svgdoc.getElementById("select_delete");
	insert_button.setAttributeNS(null,"style","fill:black; stroke:black");
	move_button.setAttributeNS(null,"style","fill:red; stroke:black");
	delete_button.setAttributeNS(null,"style","fill:black; stroke:black");
	var insert_text = svgdoc.getElementById("texte_inser");
	var move_text = svgdoc.getElementById("texte_move");
	var delete_text = svgdoc.getElementById("texte_delete");
	insert_text.setAttributeNS(null,"fill","black");
	move_text.setAttributeNS(null,"fill","red");
	delete_text.setAttributeNS(null,"fill","black");
	var req = AJAX("moveButtonpressed");
  	queryServerNow(req);
	req.send(evt);
}

function delete_selected (evt)
{
	deleteButtonActive = true;
	var insert_button = svgdoc.getElementById("select_insert");
	var move_button = svgdoc.getElementById("select_move");
	var delete_button = svgdoc.getElementById("select_delete");
	insert_button.setAttributeNS(null,"style","fill:black; stroke:black");
	move_button.setAttributeNS(null,"style","fill:black; stroke:black");
	delete_button.setAttributeNS(null,"style","fill:red; stroke:black");
	var insert_text = svgdoc.getElementById("texte_inser");
	var move_text = svgdoc.getElementById("texte_move");
	var delete_text = svgdoc.getElementById("texte_delete");
	insert_text.setAttributeNS(null,"fill","black");
	move_text.setAttributeNS(null,"fill","black");
	delete_text.setAttributeNS(null,"fill","red");
	var req = AJAX("deleteButtonpressed");
  	queryServerNow(req);
	req.send(evt); 
}

function mouse_down(evt)
{
	var req = AJAX("mouse1press?"+evt.clientX+"?"+evt.clientY);
  	queryServerNow(req);
	req.send(evt);
}

function mouse_motion(evt)
{
	var req = AJAX("mouse1motion?"+evt.clientX+"?"+evt.clientY);
  	queryServerNow(req);
	req.send(evt);
}

function mouse_relea(evt)
{
	var req = AJAX("mouse1released?"+evt.clientX+"?"+evt.clientY);
  	queryServerNow(req);
	req.send(evt);
}

function window_opened (evt)
{
	alert("bonjour");
	var req = AJAX("open_window");
  	queryServerNow(req);
	req.send(evt);
}

//==============================================================================
//Initilization function
//==============================================================================

function init(evt) {
  // page layout:
  //document.documentElement.setAttribute("viewBox", "0 0 1024 768");
  svgdoc=evt.target.ownerDocument;
 
 	// Register event listeners for all the 4 buttons
  insertButton = document.getElementById("select_insert");
  insertButton.addEventListener("mousedown", insert_selected, false);
   
  moveButton = document.getElementById("select_move");
  moveButton.addEventListener("mousedown", move_selected, false);
  
  deleteButton = document.getElementById("select_delete");
  deleteButton.addEventListener("mousedown", delete_selected, false);
  
  openButton = document.getElementById("open_window");
  openButton.addEventListener("mousedown", window_opened, false);
  
  mouse1pressed = document.getElementById("rectangle");
  mouse1pressed.addEventListener("mousedown", mouse_down, false);
  
  mouse1motion = document.getElementById("rectangle");
  mouse1motion.addEventListener("mousemove", mouse_motion, false);
  
  mouse1relea = document.getElementById("rectangle");
  mouse1relea.addEventListener("mouseup", mouse_relea, false);
  
	// Tell the server were ready to go, so initilize thyself!
  var req = new XMLHttpRequest();
  req.open("POST", "/?type=init", true); // ASYNC Request    
  req.onreadystatechange = function() {}
  req.send(null); 
    
  
}

